'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Fifo = function () {
    function Fifo() {
        _classCallCheck(this, Fifo);

        this.queue = [];
        this.inProgress = false;
    }

    _createClass(Fifo, [{
        key: 'push',
        value: function push(callback) {
            this.queue.push(callback);
            this.check('push');
        }
    }, {
        key: 'check',
        value: function check(calledBy) {
            if (this.inProgress || this.queue.length === 0) {
                return;
            }
            this.run();
        }
    }, {
        key: 'run',
        value: function run() {
            var _this = this;

            this.inProgress = true;
            setTimeout(function () {
                var callback = _this.queue[0];
                callback(function () {
                    return _this.done();
                });
            }, 0);
        }
    }, {
        key: 'done',
        value: function done() {
            this.queue.shift();
            this.inProgress = false;
            this.check('done');
        }
    }, {
        key: 'length',
        get: function get() {
            return this.queue.length;
        }
    }]);

    return Fifo;
}();

module.exports = Fifo;